pidgin: dbus-server.h File Reference

pidgin 2.14.4

Loading...
Searching...
No Matches
Data Structures | Macros | Typedefs | Functions
dbus-server.h File Reference
libpurple

Purple DBUS Server. More...

`#include "dbus-purple.h"`
`#include "value.h"`
`#include "dbus-bindings.h"`
`#include "dbus-types.h"`

Go to the source code of this file.

## Data Structures
struct | _PurpleDBusType

## Macros
#define | PURPLE_DBUS_TYPE(type) (&PURPLE_DBUS_TYPE_##type)
#define | PURPLE_DBUS_DECLARE_TYPE(type) extern PurpleDBusType PURPLE_DBUS_TYPE_##type;
#define | PURPLE_DBUS_DEFINE_TYPE(type) PurpleDBusType PURPLE_DBUS_TYPE_##type = { NULL };
#define | PURPLE_DBUS_DEFINE_INHERITING_TYPE(type, parent) PurpleDBusType PURPLE_DBUS_TYPE_##type = { PURPLE_DBUS_TYPE(parent) };
#define | PURPLE_DBUS_RETURN_FALSE_IF_DISABLED(plugin)
#define | DBUS_EXPORT
| Macro DBUS_EXPORT expands to nothing.

## Typedefs
typedef typedefG_BEGIN_DECLS struct _PurpleDBusType | PurpleDBusType
| Types of pointers are identified by the ADDRESS of a PurpleDbusType object.

## Functions
void | purple_dbus_init_ids (void)
| Initializes purple dbus pointer registration engine.
void | purple_dbus_register_pointer (gpointer node, PurpleDBusType *type)
| Registers a typed pointer.
void | purple_dbus_unregister_pointer (gpointer node)
| Unregisters a pointer previously registered with purple_dbus_register_pointer.
void | purple_dbus_signal_emit_purple (const char *name, int num_values, PurpleValue **values, va_list vargs)
| Emits a dbus signal.
const char * | purple_dbus_get_init_error (void)
| Returns whether Purple's D-BUS subsystem is up and running.
void * | purple_dbus_get_handle (void)
| Returns the dbus subsystem handle.
gboolean | purple_dbus_is_owner (void)
| Determines whether this instance owns the DBus service name.
void | purple_dbus_init (void)
| Starts Purple's D-BUS server.
void | purple_dbus_uninit (void)
| Uninitializes Purple's D-BUS server.

## Detailed Description

Purple DBUS Server.

See also
  DBus Server Signals

Definition in file dbus-server.h.

## Macro Definition Documentation

## ◆ DBUS_EXPORT

#define DBUS_EXPORT

Macro DBUS_EXPORT expands to nothing.

It is used to indicate to the dbus-analyze-functions.py script that the given function should be available to other applications through DBUS. If dbus-analyze-functions.py is run without the "--export-only" option, this prefix is ignored.

Definition at line 203 of file dbus-server.h.

## ◆ PURPLE_DBUS_DECLARE_TYPE

#define PURPLE_DBUS_DECLARE_TYPE | ( |  | type | ) | extern PurpleDBusType PURPLE_DBUS_TYPE_##type;

Definition at line 71 of file dbus-server.h.

## ◆ PURPLE_DBUS_DEFINE_INHERITING_TYPE

#define PURPLE_DBUS_DEFINE_INHERITING_TYPE | ( |  | type,
|  |  | parent
| ) |  | PurpleDBusType PURPLE_DBUS_TYPE_##type = { PURPLE_DBUS_TYPE(parent) };

Definition at line 77 of file dbus-server.h.

## ◆ PURPLE_DBUS_DEFINE_TYPE

#define PURPLE_DBUS_DEFINE_TYPE | ( |  | type | ) | PurpleDBusType PURPLE_DBUS_TYPE_##type = { NULL };

Definition at line 74 of file dbus-server.h.

## ◆ PURPLE_DBUS_RETURN_FALSE_IF_DISABLED

#define PURPLE_DBUS_RETURN_FALSE_IF_DISABLED | ( |  | plugin | ) |

Value:
if (purple_dbus_get_init_error() != NULL) \
{ \
gchar *title; \
title = g_strdup_printf("Unable to Load %s Plugin", plugin->info->name); \
purple_notify_error(NULL, title, \
_("Purple's D-BUS server is not running for the reason listed below"), \
_(purple_dbus_get_init_error())); \
g_free(title); \
return FALSE; \
}
purple_dbus_get_init_error
const char * purple_dbus_get_init_error(void)
Returns whether Purple's D-BUS subsystem is up and running.

Definition at line 80 of file dbus-server.h.

## ◆ PURPLE_DBUS_TYPE

#define PURPLE_DBUS_TYPE | ( |  | type | ) | (&PURPLE_DBUS_TYPE_##type)

Definition at line 68 of file dbus-server.h.

## Typedef Documentation

## ◆ PurpleDBusType

typedef typedefG_BEGIN_DECLS struct _PurpleDBusType PurpleDBusType

Types of pointers are identified by the ADDRESS of a PurpleDbusType object.

This way, plugins can easily access types defined in purple proper as well as introduce their own types that will not conflict with those introduced by other plugins.

The structure PurpleDbusType has only one element (PurpleDBusType::parent), a contains a pointer to the parent type, or `NULL` if the type has no parent. Parent means the same as the base class in object oriented programming.

Definition at line 48 of file dbus-server.h.

## Function Documentation

## ◆ purple_dbus_get_handle()

void * purple_dbus_get_handle | ( | void |  | ) |

Returns the dbus subsystem handle.

Returns
  The dbus subsystem handle.

## ◆ purple_dbus_get_init_error()

const char * purple_dbus_get_init_error | ( | void |  | ) |

Returns whether Purple's D-BUS subsystem is up and running.

If it's NOT running then purple_dbus_dispatch_init() failed for some reason, and a message should have been purple_debug_error()'ed.

Purple plugins that use D-BUS should use the PURPLE_DBUS_RETURN_FALSE_IF_DISABLED macro to short-circuit initialization if Purple's D-BUS subsystem is not running.

Returns
  If the D-BUS subsystem started with no problems then this will return NULL and everything will be hunky dory. If there was an error initializing the D-BUS subsystem then this will return an error message explaining why.

## ◆ purple_dbus_init()

void purple_dbus_init | ( | void |  | ) |

Starts Purple's D-BUS server.

It is responsible for handling DBUS requests from other applications.

## ◆ purple_dbus_init_ids()

void purple_dbus_init_ids | ( | void |  | ) |

Initializes purple dbus pointer registration engine.

Remote dbus applications need a way of addressing objects exposed by purple to the outside world. In purple itself, these objects (such as PurpleBuddy and company) are identified by pointers. The purple dbus pointer registration engine converts pointers to handles and back.

In order for an object to participate in the scheme, it must register itself and its type with the engine. This registration allocates an integer id which can be resolved to the pointer and back.

Handles are not persistent. They are reissued every time purple is started. This is not good; external applications that use purple should work even whether purple was restarted in the middle of the interaction.

Pointer registration is only a temporary solution. When PurpleBuddy and similar structures have been converted into gobjects, this registration will be done automatically by objects themselves.

By the way, this kind of object-handle translation should be so common that there must be a library (maybe even glib) that implements it. I feel a bit like reinventing the wheel here.

## ◆ purple_dbus_is_owner()

gboolean purple_dbus_is_owner | ( | void |  | ) |

Determines whether this instance owns the DBus service name.

Since
  2.1.0

## ◆ purple_dbus_register_pointer()

void purple_dbus_register_pointer | ( | gpointer | node,
|  | PurpleDBusType * | type
| ) |  |

Registers a typed pointer.

Parameters

  node | The pointer to register.
  type | Type of that pointer.

## ◆ purple_dbus_signal_emit_purple()

void purple_dbus_signal_emit_purple | ( | const char * | name,
|  | int | num_values,
|  | PurpleValue ** | values,
|  | va_list | vargs
| ) |  |

Emits a dbus signal.

Parameters

  name | The name of the signal ("bla-bla-blaa")
  num_values | The number of parameters.
  values | Array of pointers to PurpleValue objects representing the types of the parameters.
  vargs | A va_list containing the actual parameters.

## ◆ purple_dbus_unregister_pointer()

void purple_dbus_unregister_pointer | ( | gpointer | node | ) |

Unregisters a pointer previously registered with purple_dbus_register_pointer.

Parameters

  node | The pointer to register.